import { createLayout, createSVGUrl, createRandom } from "../dist/nugget.js";

const nuggetElementWrapper = document.querySelector(".nugget-elements");

console.time("s");
createLayout(".container", async (layout, target) => {
  nuggetElementWrapper.innerHTML = "";

  layout.rects.forEach((r) => {
    const el = document.createElement("div");

    el.style.cssText = `
      position: absolute;
      width: ${r.width}px;
      height: ${r.height}px;
      top: ${r.y}px;
      left: ${r.x}px;
      background-color: hsla(0, 100%, 0%, 0.125);
      background-image: url(https://picsum.photos/seed/${r.id}/800);
      background-size: cover;
      background-position: center center;
      border-radius: 8px;
    `;

    nuggetElementWrapper.appendChild(el);
  });
});
