function getContentRects(target, elements) {
  return [...elements].map((el) => {
    const instanceBounds = target.getBoundingClientRect();
    const elBounds = el.getBoundingClientRect();

    const offsetX = elBounds.left - instanceBounds.left;
    const offsetY = elBounds.top - instanceBounds.top;

    return {
      x: offsetX,
      y: offsetY,
      width: elBounds.width,
      height: elBounds.height,
    };
  });
}

function createObserver(target, callback) {
  const patternAvoidElements = target.querySelectorAll("[data-track-bounds]");

  [target, ...patternAvoidElements].forEach((el) => {
    new ResizeObserver(() => {
      const { width, height } = target.getBoundingClientRect();
      callback(width, height, getContentRects(target, patternAvoidElements));
    }).observe(el);
  });
}

export { createObserver };
