const defaults = {
  "--layout-width": null,
  "--layout-height": null,
  "--min-content-gap": 8,
  "--min-pattern-gap": 8,
  "--min-cell-size": 8,
  "--max-cell-size": 16,
  "--fill-iterations": 100_000,
  "--seed": Math.random() * 100_000_000,
};

const el = document.createElement("div");
el.style.display = "none";
document.body.appendChild(el);

function parseCSSValue(value) {
  el.style.width = value;

  return parseFloat(window.getComputedStyle(el).getPropertyValue("width"));
}

function getCSSValues(target) {
  const styles = window.getComputedStyle(target);
  const definedValues = {};

  Object.keys(defaults).forEach((k) => {
    if (
      [
        "--seed",
        "--fill-iterations",
        "--layout-width",
        "--layout-height",
      ].includes(k)
    ) {
      const value = parseFloat(styles.getPropertyValue(k));

      if (!isNaN(value)) {
        definedValues[k] = value;
      }

      return;
    }

    const value = parseCSSValue(styles.getPropertyValue(k));

    if (!isNaN(value)) {
      definedValues[k] = value;
    }
  });

  return Object.assign({}, defaults, definedValues);
}

export { getCSSValues };
