function mulberry32(a) {
  return function () {
    let t = (a += 0x6d2b79f5);

    t = Math.imul(t ^ (t >>> 15), t | 1);
    t ^= t + Math.imul(t ^ (t >>> 7), t | 61);

    return ((t ^ (t >>> 14)) >>> 0) / 4294967296;
  };
}

function hashSeed(seed) {
  return seed.split("").reduce((acc, curr) => {
    return (acc += curr.charCodeAt(0));
  }, 0);
}

function createRandom(seed) {
  if (typeof seed === "string") {
    seed = hashSeed(seed);
  }

  const prng = mulberry32(seed);

  return function (min = 0, max = 1, snap = 0.1) {
    return Math.round((prng() * (max - min) + min) / snap) * snap;
  };
}

export { createRandom };
