function dist(x1, y1, x2, y2) {
  const a = x1 - x2;
  const b = y1 - y2;

  return Math.sqrt(a * a + b * b);
}

function calcRectDistance(r1, r2) {
  const x1 = r1.x;
  const y1 = r1.y;
  const x1b = r1.x + r1.width;
  const y1b = r1.y + r1.height;

  const x2 = r2.x;
  const y2 = r2.y;
  const x2b = r2.x + r2.width;
  const y2b = r2.y + r2.height;

  const top = y1b < y2;
  const left = x2b < x1;
  const bottom = y2b < y1;
  const right = x1b < x2;

  if (top && left) {
    return dist(x1, y1b, x2b, y2);
  } else if (left && bottom) {
    return dist(x1, y1, x2b, y2b);
  } else if (bottom && right) {
    return dist(x1b, y1, x2, y2b);
  } else if (right && top) {
    return dist(x1b, y1b, x2, y2);
  } else if (left) {
    return x1 - x2b;
  } else if (right) {
    return x2 - x1b;
  } else if (bottom) {
    return y1 - y2b;
  } else if (top) {
    return y2 - y1b;
  } else {
    return 0;
  }
}

function rectDistance(r1, r2) {
  return Math.min(...r2.map((r) => calcRectDistance(r1, r)));
}

export { rectDistance };
